

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

RemoveColorCodes = function(str)
  return str:gsub("<rgb=#......>", ""):gsub("</rgb>", "")
end


----------------------------------------------------------------------------------------------------

mwPos = Turbine.PluginData.Load(Turbine.DataScope.Character, "Cognizance");

local lp = Turbine.Gameplay.LocalPlayer:GetInstance()
local lpName = lp:GetName();
local trackMessage = "You feel as though you are being followed...";
StealthMessages = {}

--local burgStealthMessage = lpName.." applied a benefit with Sneak on "..lpName.."."
--local burgHipsMessage = lpName.." applied a benefit with Improved Hide in Plain Sight on "..lpName.."."
--local elfStealthMessage = lpName.." applied a benefit with Silvan Shadows on "..lpName.."."

--local wargStealthMessage = lpName.." applied a benefit with Stealth on "..lpName.."."
--local wargHipsMessage = lpName.." applied a benefit with Disappear on "..lpName.."."
--local spiderShortBurrowMessage = lpName.." applied a benefit with Trapdoor Sanctuary on "..lpName.."."
--local spiderLongBurrowMessage = lpName.." applied a benefit with Lie In Wait on "..lpName.."."

local IsAFreep = false
if(lp:GetAlignment() == 1) then
  IsAFreep = true
  
  if(lp:GetClass() == 40) then -- Burglar
    StealthMessages["burgStealth"] = lpName.." applied a benefit with Sneak on "..lpName.."."
    StealthMessages["burgHips"] = lpName.." applied a benefit with Improved Hide in Plain Sight on "..lpName.."."
  elseif(lp:GetClass() == 162) then -- Hunter
    StealthMessages["hunterStealth"] = lpName.." applied a benefit with Camouflage on "..lpName.."."
  end
  
  if(lp:GetRace() == 65) then -- Elf
    StealthMessages["elfStealth"] = lpName.." applied a benefit with Silvan Shadows on "..lpName.."."
  elseif(lp:GetRace() == 81) then -- Hobbit
    StealthMessages["hobbitStealth"] = lpName.." applied a benefit with Hobbit Silence on "..lpName.."."
  end
  
  -- Add Share The Fun... I guess
else
  --Turbine.Shell.WriteLine(lp:GetClass())
  if(lp:GetClass() == 127) then -- Spider
    StealthMessages["spiderShortBurrow"] = lpName.." applied a benefit with Trapdoor Sanctuary on "..lpName.."."
    StealthMessages["spiderLongBurrow"] = lpName.." applied a benefit with Lie In Wait on "..lpName.."."
  elseif(lp:GetClass() == 126) then -- Warg
    StealthMessages["wargStealth"] = lpName.." applied a benefit with Stealth on "..lpName.."."
    StealthMessages["wargHips"] = lpName.." applied a benefit with Disappear on "..lpName.."."
  end
end

--Turbine.Shell.WriteLine("Alignment: "..lp:GetAlignment());


local mwwidth = 90;
local mwheight = mwwidth + 25;
MainWindow = Turbine.UI.Window()
if(mwPos == nil) then
  MainWindow:SetPosition((Turbine.UI.Display:GetWidth()/2) - 40, 0)
else
  MainWindow:SetPosition(mwPos["x"], mwPos["y"]);
end
MainWindow:SetSize(mwwidth, mwheight);
MainWindow:SetVisible(true);
MainWindow:SetWantsKeyEvents(true);
MainWindow.loaded = false;

local twsize = 80;
TrackedIcon = Turbine.UI.Window()
TrackedIcon:SetParent(MainWindow)
TrackedIcon:SetPosition(0,25);
--TrackedIcon:SetPosition((Turbine.UI.Display:GetWidth()/2) - 40, 0)
TrackedIcon:SetSize(twsize, twsize);
if(IsAFreep) then
  TrackedIcon:SetBackground("Turwe\\Cognizance\\tracked_icon.tga");
else
  TrackedIcon:SetBackground("Turwe\\Cognizance\\hunter_icon_combined.tga");
end
TrackedIcon:SetStretchMode(2);
TrackedIcon:SetZOrder(50);
TrackedIcon.PulseStartTime = 0;
TrackedIcon.TrackCount = 0;

local tlwidth = 60
local tlheight = 60
TrackedLabel = Turbine.UI.Label()
TrackedLabel:SetParent(MainWindow);
TrackedLabel:SetSize(tlwidth, tlheight);
TrackedLabel:SetPosition(mwwidth-tlwidth, mwheight-tlheight);
TrackedLabel:SetTextAlignment(Turbine.UI.ContentAlignment.BottomRight);
if(IsAFreep) then
  TrackedLabel:SetOutlineColor( Turbine.UI.Color( .8, 0, 0 ) );
else
  TrackedLabel:SetOutlineColor( Turbine.UI.Color( 0, 0, .8 ) );
end
TrackedLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
TrackedLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold25);
TrackedLabel:SetSelectable(false);

MoveLabel = Turbine.UI.Label()
MoveLabel:SetParent(MainWindow)
MoveLabel:SetSize(mwwidth, 25)
MoveLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
MoveLabel:SetText("Tracked Icon")
MoveLabel:SetOutlineColor( Turbine.UI.Color( .1, .1, .1 ) );
MoveLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
MoveLabel:SetFont(Turbine.UI.Lotro.Font.Arial12);
MoveLabel:SetSelectable(false);
MoveLabel:SetVisible(false);

MovePanel = Turbine.UI.Window()
MovePanel:SetParent(MainWindow)
MovePanel:SetSize(mwwidth, mwheight)
MovePanel:SetVisible(false);

MainWindow.Update = function()
  if not MainWindow.loaded then
    MainWindow.loaded=true;
    Plugins["Cognizance"].Unload = function(self,sender,args)
      MainWindow.UnloadData();
    end
    MainWindow:SetWantsUpdates(false);
  end
end

MainWindow.KeyDown = function(sender, args)
  if((args["Control"]) and (args["Action"] == 268435579)) then -- ctrl+\
    MainWindow.ToggleMoveMode();
  end
end

MainWindow.UnloadData = function()
  local temp = {}
  temp["x"] = MainWindow:GetLeft();
  temp["y"] = MainWindow:GetTop();
  Turbine.PluginData.Save(Turbine.DataScope.Character, "Cognizance", temp);
end

MainWindow.ToggleMoveMode = function()
  if(MovePanel:IsVisible()) then -- turn off Move Mode
    if(TrackedIcon.TrackCount == 0) then
      TrackedIcon:SetVisible(false);
    end
    MoveLabel:SetVisible(false);
    MovePanel:SetVisible(false);
  else -- turn on Move Mode
    if(TrackedIcon.TrackCount == 0) then
      TrackedIcon:SetVisible(true);
    end
    MoveLabel:SetVisible(true);
    MovePanel:SetVisible(true);
    MovePanel:SetZOrder(TrackedIcon:GetZOrder() + 1);
  end
end

MainWindow.isMoving = false;
MainWindow.xOffset = 0;
MainWindow.yOffset = 0;
MovePanel.MouseMove = function()
  if MainWindow.isMoving then
    local curX, curY = MainWindow:GetPosition();
    local newXOffset, newYOffset = MainWindow:GetMousePosition();
    MainWindow:SetPosition(curX + newXOffset - MainWindow.xOffset, curY + newYOffset - MainWindow.yOffset);
  end
end

MovePanel.MouseDown = function()
  --Turbine.Shell.WriteLine("Mouse down");
  MainWindow.xOffset, MainWindow.yOffset = MainWindow:GetMousePosition();
  MainWindow.isMoving = true;
end

MovePanel.MouseUp = function()
  --Turbine.Shell.WriteLine("Mouse up");
  MainWindow.isMoving = false;
  local temp = {}
  temp["x"] = MainWindow:GetLeft();
  temp["y"] = MainWindow:GetTop();
  Turbine.PluginData.Save(Turbine.DataScope.Character, "Cognizance", temp);
end

TrackedIcon.Update = function()
  local curTime = Turbine.Engine.GetGameTime()
  local pulseInterval = 1;
  
  
  if(curTime >= (TrackedIcon.PulseStartTime + pulseInterval)) then
    TrackedIcon:SetOpacity(1);
    TrackedIcon.PulseStartTime = curTime;
  else
    TrackedIcon:SetOpacity(1 - ((curTime - TrackedIcon.PulseStartTime)/(pulseInterval*1.5)));
  end
  
  --Turbine.Shell.WriteLine(Turbine.Engine.GetGameTime());
end

TrackedIcon.Reset = function()
  TrackedIcon:SetOpacity(1);
  TrackedIcon.PulseStartTime = 0;
  TrackedLabel:SetVisible(false);
end

TrackedIcon.MouseClick = function(sender, args)
  if(args["Button"] == 2) then
    StealthDetected()
  end
end

TrackDetected = function()
  if(TrackedIcon.TrackCount > 0) then -- increment the track count
    TrackedIcon.TrackCount = TrackedIcon.TrackCount + 1;
    TrackedLabel:SetText("x"..TrackedIcon.TrackCount.."!");
    TrackedLabel:SetVisible(true);
  else -- display the icon and start updating
    TrackedIcon:SetVisible(true);
    TrackedIcon.PulseStartTime = Turbine.Engine.GetGameTime();
    TrackedIcon:SetWantsUpdates(true);
    TrackedIcon.TrackCount = 1;
  end  
end

StealthDetected = function()
  TrackedIcon:SetVisible(false);
  TrackedIcon:SetWantsUpdates(false);
  TrackedIcon.TrackCount = 0;
  TrackedIcon.Reset();
end



Turbine.Chat.Received = function(sender, args)
  
  if(args["ChatType"] == nil) then 
    --Turbine.Shell.WriteLine("ChatType was nil.")
    do return end 
  end
  
  local message = RemoveColorCodes(string.trim(args["Message"]))
  
  
  if(args["ChatType"] == 4) then -- This is general - look for "You feel as if you're being followed..."
    --Turbine.Shell.WriteLine("General Chat Channel detected.")
    if(message == trackMessage) then
      TrackDetected();
    end
  elseif(args["ChatType"] == 34) then
    for k, j in pairs(StealthMessages) do
      if(message == j) then
        StealthDetected()
        do return end
      end
    end
  elseif(args["ChatType"] == 20) then  -- Check for player death
    if(not(message:find("incapacitated") == nil)) then
      --Turbine.Shell.WriteLine("Incapacitation detected.")
      StealthDetected()
    end
  end
  
end

MainWindow:SetWantsUpdates(true);